#
# spec file for package leafnode
#
# Copyright (c) 2015 SUSE LINUX GmbH, Nuernberg, Germany.
#
# All modifications and additions to the file contributed by third parties
# remain the property of their copyright owners, unless otherwise agreed
# upon. The license for this file, and modifications and additions to the
# file, is the same license as for the pristine package itself (unless the
# license for the pristine package is not an Open Source License, in which
# case the license is the MIT License). An "Open Source License" is a
# license that conforms to the Open Source Definition (Version 1.9)
# published by the Open Source Initiative.

# Please submit bugfixes or comments via http://bugs.opensuse.org/
#


Name:           leafnode
Version:        1.11.11
Release:        5.4
Summary:        A Leaf Site NNTP Server
License:        LGPL-2.1+ and SUSE-Public-Domain and MIT
Group:          Productivity/Networking/News/Servers
Url:            http://sourceforge.net/projects/leafnode/
Source0:        http://downloads.sourceforge.net/%{name}/%{name}-%{version}.tar.xz
Source1:        README.SuSE
Source2:        leafnode.cron.daily
Source3:        filters
Source4:        leafnode.xinetd
Source5:        leafnode-fetch.cron
Source6:        http://downloads.sourceforge.net/%{name}/%{name}-%{version}.tar.xz.asc
# https://www.freebsd.org/doc/en_US.ISO8859-1/books/handbook/pgpkeys-developers.html#pgpkey-mandree
Source7:        leafnode.keyring
Patch0:         leafnode-1.11.6-spooldir-permissions.diff
BuildRequires:  pcre-devel >= 2.06
%if %{?suse_version} == 1110
BuildRequires:  xz
%endif
Requires:       cron
# FIXME: use proper Requires(pre/post/preun/...)
PreReq:         /bin/cat
PreReq:         /bin/mkdir
Conflicts:      cnews
Conflicts:      inn
Provides:       nntp_daemon
BuildRoot:      %{_tmppath}/%{name}-%{version}-build

%description
Leafnode is a small NNTP server for leaf sites without permanent
connections to the Internet. It supports a subset of NNTP and is able
to automatically fetch the newsgroups the user reads regularly from the
ISP's news server.

%prep
%setup -q
%patch0

%build
CFLAGS="-Wall %{optflags}"
%configure --with-ipv6 \
    --sysconfdir=%{_sysconfdir}/%{name} \
    --with-spooldir=%{_localstatedir}/spool/news \
    --with-lockfile=%{_localstatedir}/spool/news/leaf.node/lock.file
make %{?_smp_mflags}

%check
make %{?_smp_mflags} check

%install
make DESTDIR=%{buildroot} install %{?_smp_mflags}
mkdir -p %{buildroot}/%{_sysconfdir}/cron.daily  %{buildroot}/%{_sysconfdir}/xinetd.d
install -m 755 %{SOURCE2} %{buildroot}/%{_sysconfdir}/cron.daily/%{name}
install -m 644 %{SOURCE4} %{buildroot}/%{_sysconfdir}/xinetd.d/%{name}
cp %{buildroot}/%{_sysconfdir}/%{name}/config.example %{buildroot}/%{_sysconfdir}/%{name}/config
install -m 644 %{SOURCE1} .
install -m 640 %{SOURCE3} %{buildroot}/%{_sysconfdir}/%{name}
install -d -m 755 %{buildroot}%{_mandir}/de/man1
install -d -m 755 %{buildroot}%{_mandir}/de/man8
# Get rid of files we don't want to package or package with doc below
rm -f %{buildroot}/%{_sysconfdir}/%{name}/*.dist
rm -f %{buildroot}/%{_sysconfdir}/%{name}/UNINSTALL-daemontools
rm -f %{buildroot}/%{_sysconfdir}/%{name}/filters.example
mkdir examples
cp -a update.sh tools examples
cp %{SOURCE5} examples

%files
%defattr(-,root,root)
%attr(640,root,news) %config(noreplace) %{_sysconfdir}/%{name}/config
%attr(440,root,news) %config %{_sysconfdir}/%{name}/config.example
%attr(640,root,news) %config(noreplace) %{_sysconfdir}/%{name}/filters
%attr(755,root,root) %config(noreplace) %{_sysconfdir}/cron.daily/%{name}
%attr(644,root,root) %config(noreplace) %{_sysconfdir}/xinetd.d/%{name}
%attr(750,root,news) %dir %{_sysconfdir}/%{name}
%doc ChangeLog COPYING CREDITS NEWS FAQ.txt FAQ.pdf
%doc README README.SuSE README-FQDN
%doc filters.example
%doc ADD-ONS KNOWNBUGS
%doc doc_german/INSTALL_de
%doc doc_german/LIESMICH-daemontools
%doc doc_german/README
%doc doc_german/README_de
%doc examples/
%doc %{_mandir}/man1/newsq.1.gz
%doc %{_mandir}/man1/leafnode-version.1.gz
%doc %{_mandir}/man8/applyfilter.8.gz
%doc %{_mandir}/man8/checkgroups.8.gz
%doc %{_mandir}/man8/fetchnews.8.gz
%doc %{_mandir}/man8/leafnode.8.gz
%doc %{_mandir}/man8/texpire.8.gz
%{_bindir}/newsq
%{_bindir}/leafnode-version
%{_sbindir}/applyfilter
%{_sbindir}/checkgroups
%{_sbindir}/fetchnews
%{_sbindir}/leafnode
%{_sbindir}/texpire
%attr(775,news,news) %{_localstatedir}/spool/news

%changelog
* Tue Aug 25 2015 astieger@suse.com
- leafnode 1.11.11:
  * The configfile parser now strips whitespace between a
    configuration parameter's value and a trailing comment.
  * The roff manual page sources now render proper hyphens (-),
    minus characters (\-) and en-dashes (\[en]) depending on
    their context. This is so that copying-and-pasting from the
    manual page works properly.
  * The code that checks if the peer is local now properly deals
    with IPv4 mapped IPv6 addresses.
* Tue Mar 24 2015 astieger@suse.com
- format spec file, remove gpg-offline fixing SLE 12 build
* Tue Jun 11 2013 andreas.stieger@gmx.de
- 1.11.10 - no user visible changes
  * source changes affecting build system and portablility
  * fixes an abort in verbose mode when running fetchnews 1.11.9
- 1.11.9 - no user visible changes
  * source changes affecting build system and compiler warnings
- packaging changes:
  * require pcre >= 2.06
  * droped leafnode-1.11.8-gethostbyname-2-getaddrinfo.patch :
    accepted upstream
  * verify source signature
* Mon Jan 14 2013 andreas.stieger@gmx.de
- reformat spec file, licence is LGLP-2.1+, remove INSTALL
* Sun Sep 25 2011 andreas.stieger@gmx.de
- update list of authors to include current maintainer
* Thu Aug 18 2011 boris@steki.net
- add patch for getaddrinfo
* Sat Jul 30 2011 andreas.stieger@gmx.de
- update to upstream 1.11.18
  * 1.11.8, 2010-06-12
  [#]## BUGFIXES
- Performance optimization, reported by Gary R. Schmidt.
- Fix a compiler warning on computers where "long" is a wider type than "int",
  such as many 64-bit computers.
- Fix compiler warnings on computers where "long" is a wider type than
  "time_t", such as NetBSD 5.X on 64-bit computers.
- Fix compiler warning "dereferencing type-punned pointer will break
  strict-aliasing rules"
- Fix a file descriptor leak in fetchnews.c's getbody_newno function; reported
  to Debian BTS by Helmut Grohne, fix by Robert Grimm.
  [#]## CHANGES
- Leafnode now enables IPv6 support by default. Use --without-ipv6 to disable.
- Leafnode now supports detecting if a peer is in a local network also
  for IPv6 global addresses, providing that the host OS provides getifaddrs().
  This comprises Linux, NetBSD, FreeBSD, but not, for instance, Solaris 10.
  Reported missing by M. G. Berberich.
- Leafnode is now always compiled in maintainer mode.
  This has no impact on run-time behaviour.
- Leafnode now assumes that handlers for signal() do not return a value.
  [#]## WORKAROUND
- Skip arbitrary amounts of contiguous CR right before LF. Reported by John R.
  Myers.
  [#]## DOCUMENTATION
- Remove the long-obsoleted README.FIRST file.
- The FAQ has information on how to copy the spool.
- FAQ: The MAC OS X two-level namespace documentation for PCRE was removed,
  PCRE is no longer part of the leafnode distribution.
- FAQ: mention how to fix losing unsubscriptions of low-traffic groups in slrn
- config.example: The expire documentation should now be clearer and closer to
  the one in the leafnode(8) manual page. Along the lines discussed by Chris G
  and Whiskers on the leafnode mailing list.
  * 1.11.7, 2009-04-20
  [#]## WORKAROUND
- fetchnews: If the LN_SUPPRESS_DATE environment variable is defined and set
  to any value or empty, fetchnews will not test the upstream server's time by
  means of the "DATE" NNTP command.
  This can be used to quench related log messages.
  [#]## BUGFIXES
- Fix logging if texpire unlinks files without further hardlinks from
  message.id/NNN/
- Fix potential segfault on libcs that do not catch NULL for %%s formatting
  (several GNU libc versions do) when trying to retrieve delayed bodies from
  corrupt article headers. Pretend success, to purge article number from
  subscription file.  Bug reported by Chris Carr.
- Fix & change "noactive" so that it can be overridden by "fetchnews -f", as
  documented in config.example.
  Regression as side effect of 1.9.50 fix, reported by Jesse F. Hughes.
- Fix logged IP address in "connected to..., reply:" message when compiled
  without IPv6 support.
  Fixes Mandriva Bug #45605, reported by David W. Hodgins.
- Print connected to... to console as well at proper verbosity level, found
  by maintainer while debugging aforementioned bug.
- Only emit warning that no server with posting permission was found if that's
  actually needed. Reported by Christian Weiske.
- If corrupted articles had been detected, fetchnews -x NNN would not be able
  to re-fetch the said article because a 0-sized file remained in message.id,
  making fetchnews believe the article was in the spool.
  0-sized message.id/NNN/ files are now purged when checking if the article is
  already in the spool.
  Reported by Peter Bauernfeind. (de.comm.software.newsserver post, May 2008)
- Change interface enumeration to track incompatible NetBSD 5 changes.  The
  latter led to bogus connection refusals in NNTPD.  SourceForge Bug #2700756,
  by Aleksey Cheusov, fix suggested by Roy Marples.
- Add support for SIOCGIFALIAS where available (BSD) in order to obtain
  netmasks for 4.4BSD-style IP aliases.
  getifaddrs() has been suggested as well, but it isn't available everywhere,
  so we would have to keep the old code around anyways, and we can just fix
  that rather than introduce alternative code branches.
  [#]## BUGFIXES BACKPORTED FROM LEAFNODE 2
- lsort (used by make update) now detects and report errors.
- "make update" handles the lockfile properly now: it records its PID and
  removes the lock also in cases of failure.
- "make update" restores the old groupinfo file if lsort fails.
- "make update" now builds an up-to-date lsort first.
- "make update" now uses the configured NEWS_USER and _GROUP.
- "make update" is now a phony Makefile target, i. e. it will work even
  if there is a file "update" in the build directory.
  [#]## CHANGES
- When creating a Path: header (because the newsreader did not do that), use
  "not-for-mail" instead of NEWS_USER (usually "news") as the user component.
  This seems to resolve propagation issues with 2nd-hop-upstreams, as reported
  in Debian Bug#459980 by Michael Weitzel, with Universität Siegen, Germany.
- When writing to client fails, log decoded errno, too.
  This can help debugging certain firewall misconfigurations more easily.
- Undoing a wordwrap in configure.ac allows for bootstrapping on Cygwin.
- Drop obsolete mysetvbuf().
- leafnode-version now supports an additional "-v" mode to print more
  information on the installation. The output then is similar, but not
  identical - due to different feature sets - to the way leafnode-2 prints it.
  [#]## DOCUMENTATION
- Add some comments to UNINSTALL-daemontools
- Put README-FQDN* under leafnode's license. Found to be in conflict with
  Debian's DFSG by Mark Brown.
* Sat Jul 30 2011 andreas.stieger@gmx.de
- resurrect package from discontinued 11.1
- move make check to %%check section to fix rpmlint warning
- adjust %%install section to not clean out doc_german too much to make %%check work
- adjust %%files section to name files in doc_german individually
- add %%config to config.example to fix rpmlint warning
* Thu May  8 2008 seife@suse.de
- add an example crontab to fetch news every hour (bnc #382542)
* Wed Apr  9 2008 crrodriguez@suse.de
- leafnode does not remove old news threads without cron which is
  not installed by default now
* Tue Jun  5 2007 seife@suse.de
- add leafnode-1.11.6-spooldir-permissions.diff, bug 273929
- add some tricks to get the package past the rpmlint censors
* Wed Mar 21 2007 seife@suse.de
- Update to version 1.11.6:
  * do not delete articles if References: lines are malformatted
  * fix compilation with SGI IDO cc
  * reject *.site fqdn.
  * documentation fixes
  * support autoconf 2.60, fixing datarootdir-related warnings
* Tue Nov  7 2006 meissner@suse.de
- fixed use of RPM_OPT_FLAGS
* Mon Sep  4 2006 seife@suse.de
- Update to version 1.11.5:
  * applyfilter overhaul
  * fetchnews: Keep non-expiring groups (negative groupexpire date)
    active, even if they expired upstream. sf.net bug#1230256
  * some loglevel adjustments
  * fetchnews: Do not mark the active for refetch when the failed
    server has "noread" set or fetchnews is in -P (post only) mode.
  * fetchnews: Skip to next server if posting fails.
  * fetchnews: Don't POST if the server goes away after STAT.
  * various documentation fixes
- clean up pakaged documentation
* Wed Jan 25 2006 mls@suse.de
- converted neededforbuild to BuildRequires
* Fri Jan 20 2006 schwab@suse.de
- Don't strip binaries.
* Fri Oct 28 2005 ro@suse.de
- work around strange behaviour of "mkdir -p .../."
* Mon Jun 13 2005 rommel@suse.de
- update to version 1.11.3.rel (fixes bug #88489 and #83355)
* Thu Sep  2 2004 mmj@suse.de
- Remove update messages, since the versions that could trigger
  them haven't been in the distribution since +2 years [#44363]
* Sat Aug  7 2004 rommel@suse.de
- update to version 1.10.3.rel
* Mon Jun 28 2004 rommel@suse.de
- update to version 1.10.1.rel
* Thu Apr 15 2004 rommel@suse.de
- update to version 1.9.52.rel (security fix, bug #38905)
* Wed Mar  3 2004 rommel@suse.de
- update to version 1.9.51.rel (bugfix release for reliable groupinfo file
  detection)
* Mon Feb 16 2004 rommel@suse.de
- update to version 1.9.49.rel
- reworked inetd/xinetd section in README.SuSE
* Sat Jan 10 2004 adrian@suse.de
- build as user
* Wed Jul  9 2003 rommel@suse.de
- update to version 1.9.42.rel
- added doc_german directory to /usr/share/doc/packages/leafnode
* Fri Jun 13 2003 mmj@suse.de
- Remove files we don't want to package
- Package some extra ones
* Thu Mar  6 2003 rommel@suse.de
- added a configuration file for xinetd
* Thu Feb 13 2003 rommel@suse.de
- update to version 1.9.33.rel
  (fixes some bugs, enhances compatiblity with versions older
  than 1.9.23 and adds a per-server noread flag)
* Fri Jan 17 2003 rommel@suse.de
- update to version 1.9.32.rel
- added "make check" to build section
* Tue Sep 17 2002 ro@suse.de
- removed bogus self-provides
* Fri Aug 16 2002 rommel@suse.de
- Added PreReq:
* Fri Jul 26 2002 rommel@suse.de
- Update to 1.9.24.rel
- Updated README.SuSE
- Updated list of authors
* Thu Apr 25 2002 rommel@suse.de
- Update to 1.9.22
- Fixed permissions of /etc/leafnode
  (thanks to matthias.andree@gmx.de)
* Tue Feb 19 2002 grimmer@suse.de
- Updated README.SuSE to reflect 8.0 changes (thanks to Ulrich
  Mindrup for reminding me) (#13554)
* Wed Jul 11 2001 grimmer@suse.de
- Update to 1.9.19 (bugfix release)
- added "su - news -c" to texpire call in daily cron job
* Wed May  2 2001 grimmer@suse.de
- added check for existing groupinfo file to cron job
  to avoid unnecessary junk mail to root if fetchnews has
  not been run yet (#7457)
- minor changes to README.SuSE
* Sun Feb 11 2001 grimmer@suse.de
- added /etc/cron.daily/leafnode to expire old articles
  (obsoletes the entry in /etc/crontab) (#6259)
* Tue Dec  5 2000 grimmer@suse.de
- Update to 1.9.18 (bugfix release)
- bzipped sources
- removed README.SuSE from patch and added as a separate
  source file instead
* Thu Oct  5 2000 grimmer@suse.de
- Update to 1.9.17 (bugfixes)
- corrected a path name in README.SuSE
- specfile correction: only send mail to root, if
  there was an update from a very old version
* Tue Aug  8 2000 grimmer@suse.de
- Update to 1.9.15
* Mon Jun 19 2000 grimmer@suse.de
- Update to 1.9.14
* Thu Mar 30 2000 grimmer@suse.de
- Update to 1.9.12 (bugfixes)
* Thu Feb 24 2000 grimmer@suse.de
- Update to 1.9.11 (bugfixes)
* Sun Feb 20 2000 grimmer@suse.de
- patched Makefile.in to actually use mandir
* Thu Feb 17 2000 grimmer@suse.de
- update to 1.9.10
- spec file cleanups
- added Group Tag and URL
- added german documentation and man pages
- use version and mandir macro in spec file
- marked config files as "noreplace"
* Tue Nov 23 1999 grimmer@suse.de
- Added Y2K patch to nntpd.c
* Sat Oct  2 1999 grimmer@suse.de
- added Provides nntp_daemon to specfile
- modified update notice
* Mon Sep 13 1999 bs@suse.de
- ran old prepare_spec on spec file to switch to new prepare_spec.
* Mon Aug  2 1999 grimmer@suse.de
- update to 1.9.4
- added update.sh to $DOCDIR and adjusted README.SuSE
- fetch is now called fetchnews
* Tue Apr 27 1999 ro@suse.de
- configure: hardcoded paths for RPM: detections breaks with rpm-3.0
* Wed Mar 10 1999 grimmer@suse.de
- Updated specfile to send mail to root when updating from previous
  releases
- created sample filter configuration file
* Thu Mar  4 1999 grimmer@suse.de
- update to Version 1.9.2
- now uses /etc/leafnode for configuration files
- changed permissions of /etc/leafnode/config (security reasons)
- now uses /var/lock/news for locking instead of /var/run
* Tue Feb 16 1999 grimmer@suse.de
- update to Version 1.9
- now uses GNU autoconf
* Thu Jan 28 1999 grimmer@suse.de
- update to Version 1.8.1
* Thu Dec 10 1998 grimmer@suse.de
- update to Version 1.7.1
* Tue Nov 10 1998 grimmer@suse.de
- New package (Version 1.6.2)
